#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include "uart.h"
volatile uint16_t distance = 0; //tu budeme ukladat vzdialenost, ako cele cislo o velkosti 16 bitov
FILE mystdout = FDEV_SETUP_STREAM(uart_putc, NULL, _FDEV_SETUP_WRITE);

void UART_Transmit(unsigned char data) {
    while (!(UCSR0A & (1<<UDRE0))); // Caka na prazdny buffer
    UDR0 = data;
}

void trigger_pulse() {
    PORTB |= (1 << PB1);  // Nastavi Trig pin na vysoku uroven
    _delay_us(10);              // Caka 10 mikrosekund
    PORTB &= ~(1 << PB1); // Nastavi Trig pin na nizku uroven
}

uint16_t measure_pulse_width() {
    uint16_t pulse_width = 0;
    uint16_t timeout = 50000; // Aby sme nesli donekonecna

    // Caka na Echo pin, kym bude na vysokej urovni
    while (!(PINB & (1 << PB2)) && timeout--) {
        _delay_us(1);
    }

    // Mera dlzku signalu
    while ((PINB & (1 << PB2)) && timeout--) {
        _delay_us(1);
        pulse_width++;
    }

    // Vypocitame vzdialenost v cm
    uint16_t distance = pulse_width / 37;
    return distance;
}

int main(void) {
    DDRB |= (1 << PB1); // Nastavi Trig pin ako vystup
    DDRB &= ~(1 << PB2); // Nastavi Echo pin ako vstup
	PORTB |= (1 << PB2); // Ovladanie pull-up rezistoru
	
	hw_init();
    uart_init();
    stdout= &mystdout;
	
    while (1) {
         trigger_pulse(); // Posle signal na senzor
		 uint16_t distance = measure_pulse_width(); // Merame vzdialenost a vypocitame ju v cm
        printf("Vzdialenost: %d cm\n", distance); // Vypiseme vzdialenost cez napr. Putty
        _delay_ms(500); // Pockame pred dalsim meranim
    }
    return 0;
}